=== doc-translated/CMakeLists.txt ===
add_subdirectory( it )
add_subdirectory( nl )
add_subdirectory( pt )
add_subdirectory( pt_BR )
add_subdirectory( sv )
add_subdirectory( uk )
